"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _visionCameraBarcodeScanner = require("@mgcrea/vision-camera-barcode-scanner");
var _reactNativeVisionCamera = require("react-native-vision-camera");
var _reactNativeWorkletsCore = require("react-native-worklets-core");
var _Overlay = require("./components/Overlay");
var _consts = require("./utils/consts");
var _helpers = require("./utils/helpers");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const BarcodeScanner = ({
  onScan,
  barcodeTypes = _consts.DEFAULT_BARCODE_TYPES
}) => {
  const device = (0, _reactNativeVisionCamera.useCameraDevice)('back');
  const {
    hasPermission,
    requestPermission
  } = (0, _reactNativeVisionCamera.useCameraPermission)();
  const updateResult = _reactNativeWorkletsCore.Worklets.createRunOnJS(code => {
    onScan(code);
  });
  const {
    props: cameraProps
  } = (0, _visionCameraBarcodeScanner.useBarcodeScanner)({
    fps: 10,
    barcodeTypes,
    onBarcodeScanned: barcodes => {
      'worklet';

      const [barcode] = barcodes;
      if (_reactNative.Platform.OS === 'ios') {
        const {
          corners
        } = barcode.native;
        if ((0, _helpers.iOSresultInCenter)(corners)) {
          barcode?.value && updateResult(barcode.value);
        }
      } else {
        // Android
        const {
          cornerPoints
        } = barcode.native;
      }
    }
  });
  (0, _react.useEffect)(() => {
    requestPermission();
  }, []);
  if (!hasPermission) return null;
  if (device == null) {
    throw Error('Availble device with camera was not found');
  }
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: _reactNative.StyleSheet.absoluteFill
  }, hasPermission && /*#__PURE__*/_react.default.createElement(_reactNativeVisionCamera.Camera, _extends({
    style: _reactNative.StyleSheet.absoluteFill,
    device: device,
    isActive: true
  }, cameraProps)), /*#__PURE__*/_react.default.createElement(_Overlay.Overlay, null));
};
var _default = exports.default = BarcodeScanner;
//# sourceMappingURL=BarcodeScanner.js.map