function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { useEffect } from 'react';
import { Platform, StyleSheet, View } from 'react-native';
import { useBarcodeScanner } from '@mgcrea/vision-camera-barcode-scanner';
import { Camera, useCameraDevice, useCameraPermission } from 'react-native-vision-camera';
import { Worklets } from 'react-native-worklets-core';
import { Overlay } from './components/Overlay';
import { DEFAULT_BARCODE_TYPES } from './utils/consts';
import { iOSresultInCenter } from './utils/helpers';
const BarcodeScanner = ({
  onScan,
  barcodeTypes = DEFAULT_BARCODE_TYPES
}) => {
  const device = useCameraDevice('back');
  const {
    hasPermission,
    requestPermission
  } = useCameraPermission();
  const updateResult = Worklets.createRunOnJS(code => {
    onScan(code);
  });
  const {
    props: cameraProps
  } = useBarcodeScanner({
    fps: 10,
    barcodeTypes,
    onBarcodeScanned: barcodes => {
      'worklet';

      const [barcode] = barcodes;
      if (Platform.OS === 'ios') {
        const {
          corners
        } = barcode.native;
        if (iOSresultInCenter(corners)) {
          barcode?.value && updateResult(barcode.value);
        }
      } else {
        // Android
        const {
          cornerPoints
        } = barcode.native;
      }
    }
  });
  useEffect(() => {
    requestPermission();
  }, []);
  if (!hasPermission) return null;
  if (device == null) {
    throw Error('Availble device with camera was not found');
  }
  return /*#__PURE__*/React.createElement(View, {
    style: StyleSheet.absoluteFill
  }, hasPermission && /*#__PURE__*/React.createElement(Camera, _extends({
    style: StyleSheet.absoluteFill,
    device: device,
    isActive: true
  }, cameraProps)), /*#__PURE__*/React.createElement(Overlay, null));
};
export default BarcodeScanner;
//# sourceMappingURL=BarcodeScanner.js.map